(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
	(factory((global.Formik = {}),global.React));
}(this, (function (exports,React) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
};

var REACT_STATICS = {
    childContextTypes: true,
    contextTypes: true,
    defaultProps: true,
    displayName: true,
    getDefaultProps: true,
    mixins: true,
    propTypes: true,
    type: true,
};
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
var getPrototypeOf = Object.getPrototypeOf;
var objectPrototype = getPrototypeOf && getPrototypeOf(Object);
var getOwnPropertyNames = Object.getOwnPropertyNames;
function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
    if (typeof sourceComponent !== 'string') {
        if (objectPrototype) {
            var inheritedComponent = getPrototypeOf(sourceComponent);
            if (inheritedComponent && inheritedComponent !== objectPrototype) {
                hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
            }
        }
        var keys = getOwnPropertyNames(sourceComponent);
        if (getOwnPropertySymbols) {
            keys = keys.concat(getOwnPropertySymbols(sourceComponent));
        }
        for (var i = 0; i < keys.length; ++i) {
            var key = keys[i];
            if (!REACT_STATICS[key] && (!blacklist || !blacklist[key])) {
                if (propIsEnumerable.call(sourceComponent, key) || typeof targetComponent[key] === 'function') {
                    try {
                        targetComponent[key] = targetComponent[key];
                    }
                    catch (e) { }
                }
            }
        }
        return targetComponent;
    }
    return targetComponent;
}

function yupToFormErrors(yupError) {
    var errors = {};
    for (var _i = 0, _a = yupError.inner; _i < _a.length; _i++) {
        var err = _a[_i];
        if (!errors[err.path]) {
            errors[err.path] = err.message;
        }
    }
    return errors;
}
function touchAllFields(fields) {
    var touched = {};
    for (var _i = 0, _a = Object.keys(fields); _i < _a.length; _i++) {
        var k = _a[_i];
        touched[k] = true;
    }
    return touched;
}
function validateFormData(data, schema) {
    var validateData = {};
    for (var k in data) {
        if (data.hasOwnProperty(k)) {
            var key = String(k);
            validateData[key] = data[key] !== '' ? data[key] : undefined;
        }
    }
    return schema.validate(validateData, { abortEarly: false });
}
function Formik(_a) {
    var displayName = _a.displayName, _b = _a.mapPropsToValues, mapPropsToValues = _b === void 0 ? function (vanillaProps) {
        var values = {};
        for (var k in vanillaProps) {
            if (vanillaProps.hasOwnProperty(k) && typeof vanillaProps[k] !== 'function') {
                values[k] = vanillaProps[k];
            }
        }
        return values;
    } : _b, _c = _a.mapValuesToPayload, mapValuesToPayload = _c === void 0 ? function (values) {
        var payload = values;
        return payload;
    } : _c, validationSchema = _a.validationSchema, handleSubmit = _a.handleSubmit;
    return function wrapWithFormik(WrappedComponent) {
        var Formik = (function (_super) {
            __extends(Formik, _super);
            function Formik(props) {
                var _this = _super.call(this, props) || this;
                _this.setErrors = function (errors) {
                    _this.setState({ errors: errors });
                };
                _this.setTouched = function (touched) {
                    _this.setState({ touched: touched });
                };
                _this.setValues = function (values) {
                    _this.setState({ values: values });
                };
                _this.setError = function (error) {
                    _this.setState({ error: error });
                };
                _this.setSubmitting = function (isSubmitting) {
                    _this.setState({ isSubmitting: isSubmitting });
                };
                _this.handleChange = function (e) {
                    e.persist();
                    var _a = e.target, type = _a.type, name = _a.name, id = _a.id, value = _a.value, checked = _a.checked, outerHTML = _a.outerHTML;
                    var field = name ? name : id;
                    var val = /number|range/.test(type) ? parseFloat(value) : /checkbox/.test(type) ? checked : value;
                    if (!field && "development" !== 'production') {
                        console.error("Warning: You forgot to pass an `id` or `name` attribute to your input:\n\n  " + outerHTML + "\n\nFormik cannot determine which value to update. See docs for more information: https://github.com/jaredpalmer/formik#handlechange-e-reactchangeeventany--void\n");
                    }
                    var values = _this.state.values;
                    _this.setState(function (state) {
                        return (__assign({}, state, { values: __assign({}, values, (_a = {}, _a[field] = val, _a)) }));
                        var _a;
                    });
                    validateFormData(__assign({}, values, (_b = {}, _b[field] = val, _b)), validationSchema).then(function () { return _this.setState({ errors: {} }); }, function (err) { return _this.setState({ errors: yupToFormErrors(err) }); });
                    var _b;
                };
                _this.handleSubmit = function (e) {
                    e.preventDefault();
                    _this.setState({
                        touched: touchAllFields(_this.state.values),
                        isSubmitting: true,
                    });
                    var values = _this.state.values;
                    validateFormData(values, validationSchema).then(function () {
                        _this.setState({ errors: {} });
                        handleSubmit(mapValuesToPayload(_this.state.values), {
                            setTouched: _this.setTouched,
                            setErrors: _this.setErrors,
                            setError: _this.setError,
                            setSubmitting: _this.setSubmitting,
                            setValues: _this.setValues,
                            resetForm: _this.resetForm,
                            props: _this.props,
                        });
                    }, function (err) { return _this.setState({ isSubmitting: false, errors: yupToFormErrors(err) }); });
                };
                _this.handleBlur = function (e) {
                    e.persist();
                    var _a = e.target, name = _a.name, id = _a.id;
                    var field = name ? name : id;
                    _this.setState(function (state) {
                        return ({ touched: __assign({}, state.touched, (_a = {}, _a[field] = true, _a)) });
                        var _a;
                    });
                };
                _this.handleChangeValue = function (field, value) {
                    var _a = _this.state, touched = _a.touched, values = _a.values;
                    _this.setState(function (state) {
                        return (__assign({}, state, { values: __assign({}, values, (_a = {}, _a[field] = value, _a)), touched: __assign({}, touched, (_b = {}, _b[field] = true, _b)) }));
                        var _a, _b;
                    });
                    validateFormData(__assign({}, values, (_b = {}, _b[field] = value, _b)), validationSchema).then(function () { return _this.setState({ errors: {} }); }, function (err) { return _this.setState({ errors: yupToFormErrors(err) }); });
                    var _b;
                };
                _this.resetForm = function (nextProps) {
                    _this.setState({
                        isSubmitting: false,
                        errors: {},
                        touched: {},
                        error: undefined,
                        values: nextProps ? mapPropsToValues(nextProps) : mapPropsToValues(_this.props),
                    });
                };
                _this.handleReset = function () {
                    _this.setState({
                        isSubmitting: false,
                        errors: {},
                        touched: {},
                        error: undefined,
                        values: mapPropsToValues(_this.props),
                    });
                };
                _this.state = {
                    values: mapPropsToValues(props),
                    errors: {},
                    touched: {},
                    isSubmitting: false,
                };
                return _this;
            }
            Formik.prototype.render = function () {
                return (React.createElement(WrappedComponent, __assign({}, this.props, this.state, { setError: this.setError, setErrors: this.setErrors, setSubmitting: this.setSubmitting, setTouched: this.setTouched, setValues: this.setValues, resetForm: this.resetForm, handleReset: this.handleReset, handleSubmit: this.handleSubmit, handleChange: this.handleChange, handleBlur: this.handleBlur, handleChangeValue: this.handleChangeValue })));
            };
            return Formik;
        }(React.Component));
        Formik.displayName = "Formik(" + (displayName ||
            WrappedComponent.displayName ||
            WrappedComponent.name ||
            'Component') + ")";
        Formik.WrappedComponent = WrappedComponent;
        var FinalComponent = hoistNonReactStatics(Formik, WrappedComponent);
        return FinalComponent;
    };
}

exports.yupToFormErrors = yupToFormErrors;
exports.touchAllFields = touchAllFields;
exports.validateFormData = validateFormData;
exports.Formik = Formik;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=formik.umd.js.map
